let express = require("express");
var multer = require("multer");

// initialisation du module express
let app = express();
var multerData = multer();

// lieu où se trouvent les pages html/css/js/images statiqueqs
app.use(express.static("public")); // ICI IMPORTANT !

let listeRestaurants = [
  {
    nom: "MacDo",
    cuisine: "Burgers"
  },
  {
    nom: "Papa Johns",
    cuisine: "Pizzas"
  }
];
// page d'accueil
app.get("/", (req, res) => {
  // Page d’accueil
  res.sendFile(__dirname + "/public/accueilRestaurants.html");
});

// GET sur restaurants
app.get("/api/restaurants", (req, res) => {
  let limit = req.query.limit || 5;
  let page = req.query.page || 1;
  let nom = req.query.nom || "";

  let reponse = {
    msg:
      "Voici la liste des" +
      limit +
      " premiers restaurants de la page " +
      page +
      " nom = " +
      nom,
    data: listeRestaurants, // nombre de restaurants insérés
    err: ""
  };
  res.send(JSON.stringify(reponse));
});

// POST pour insérer
app.post("/api/restaurants", multerData.fields([]), function(req, res) {
  let nom = req.body.nom;
  let cuisine = req.body.cuisine;

  listeRestaurants.push({
    nom: nom,
    cuisine: cuisine
  });

  let reponse = {
    msg: "J'insère un restaurant nom = " + nom + " cuisine = " + cuisine,
    data: "id du restaurant inséré " + Math.random(),
    err: ""
  };
  res.send(JSON.stringify(reponse));
});

// DELETE pour supprimer un restaurants
app.delete("/api/restaurants/:id", (req, res) => {
  let id = req.params.id;

  let reponse = {
    msg: "Restaurant id=" + id + "supprimé",
    data: 1, // nombre de restaurants supprimés
    err: ""
  };
  res.send(JSON.stringify(reponse));
});

let port = 8085;

// On lance le serveur
let server = app.listen(port, () => {
  console.log("Serveur démarré sur le port " + port);
});
