window.onload = init;

function init() {
  new Vue({
    el: "#app",
    data: {
      restaurants: [],
      nom: "",
      cuisine: ""
    },
    mounted() {
      // appelée automatiquement avant
      // l'affichage

      // on va chercher les restaurants
      let url = "http://localhost:8080/api/restaurants";
      fetch(url)
        .then(response => {
          return response.json();
        })
        .then(responseJS => {
          console.log(responseJS.msg);
          this.restaurants = responseJS.data;
        });
    },
    methods: {
      supprimerRestaurant: function(index) {
        this.restaurants.splice(index, 1);

        let id = index;
        // on le rajoute côté serveur
        let url = "http://localhost:8080/api/restaurants/" + id;
        fetch(url, {
          method: "DELETE"
        })
          .then(response => {
            return response.json();
          })
          .then(responseJS => {
            console.log(responseJS.msg);
          });
      },
      ajouterRestaurant: function() {
        this.restaurants.push({
          name: this.nom,
          cuisine: this.cuisine
        });

        // pour les données du formulaire
        let data = new FormData();
        data.append("nom", this.nom);
        data.append("cuisine", this.cuisine);

        // on le rajoute côté serveur
        let url = "http://localhost:8080/api/restaurants";
        fetch(url, {
          method: "POST",
          body: data
        })
          .then(response => {
            return response.json();
          })
          .then(responseJS => {
            console.log(responseJS.msg);
          });

        // on remet le formulaire à zéro
        this.nom = "";
        this.cuisine = "";
      }
    }
  });
}
